Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 348)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 355)
@@ -1,111 +1,251 @@
-{
-    IBClasses = (
-        {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
-        {CLASS = NJRDateFormatter; LANGUAGE = ObjC; SUPERCLASS = NSDateFormatter; }, 
-        {
-            ACTIONS = {select = id; }; 
-            CLASS = NJRFSObjectSelector; 
-            LANGUAGE = ObjC; 
-            SUPERCLASS = NSButton; 
-        }, 
-        {
-            ACTIONS = {clearAllEntries = id; removeEntry = id; }; 
-            CLASS = NJRHistoryTrackingComboBox; 
-            LANGUAGE = ObjC; 
-            SUPERCLASS = NSComboBox; 
-        }, 
-        {CLASS = NJRIntegerFilter; LANGUAGE = ObjC; SUPERCLASS = NSNumberFormatter; }, 
-        {
-            CLASS = NJRIntervalField; 
-            LANGUAGE = ObjC; 
-            OUTLETS = {intervalUnits = NSPopUpButton; }; 
-            SUPERCLASS = NSTextField; 
-        }, 
-        {
-            ACTIONS = {stopSoundPreview = id; }; 
-            CLASS = NJRQTMediaPopUpButton; 
-            LANGUAGE = ObjC; 
-            OUTLETS = {preview = NSMovieView; }; 
-            SUPERCLASS = NSPopUpButton; 
-        }, 
-        {CLASS = NJRUnfocusableMovieView; LANGUAGE = ObjC; SUPERCLASS = NSMovieView; }, 
-        {
-            ACTIONS = {stopVoicePreview = id; }; 
-            CLASS = NJRVoicePopUpButton; 
-            LANGUAGE = ObjC; 
-            SUPERCLASS = NSPopUpButton; 
-        }, 
-        {CLASS = NSDisclosureButtonCell; LANGUAGE = ObjC; SUPERCLASS = NSButtonCell; }, 
-        {CLASS = NSObject; LANGUAGE = ObjC; }, 
-        {
-            ACTIONS = {
-                dateCompleted = id; 
-                doScriptChanged = id; 
-                doSpeakChanged = id; 
-                editAlertChanged = id; 
-                inAtChanged = id; 
-                playSoundChanged = id; 
-                setAlarm = id; 
-                setSoundRepetitionCount = id; 
-                showCalendar = id; 
-                showVolume = id; 
-                silence = id; 
-                toggleAlertEditor = id; 
-                update = id; 
-            }; 
-            CLASS = PSAlarmSetController; 
-            LANGUAGE = ObjC; 
-            OUTLETS = {
-                alertTabs = NSTabView; 
-                alertView = NSTextField; 
-                bounceDockIcon = NSButton; 
-                cancelButton = NSButton; 
-                displayMessage = NSButtonCell; 
-                doScript = NSButtonCell; 
-                doSpeak = NSButtonCell; 
-                editAlert = NSButtonCell; 
-                inAtMatrix = NSMatrix; 
-                messageField = NSTextField; 
-                playSound = NSButtonCell; 
-                script = NJRFSObjectSelector; 
-                scriptSelectButton = NSButton; 
-                setButton = NSButton; 
-                sound = NJRQTMediaPopUpButton; 
-                soundRepetitionStepper = NSStepper; 
-                soundRepetitions = NSTextField; 
-                soundRepetitionsLabel = NSTextField; 
-                soundVolumeButton = NSButton; 
-                timeCalendarButton = NSButton; 
-                timeDate = NSTextField; 
-                timeDateCompletions = NSPopUpButton; 
-                timeInterval = NJRIntervalField; 
-                timeIntervalRepeats = NSButton; 
-                timeIntervalUnits = NSPopUpButton; 
-                timeOfDay = NSTextField; 
-                timeSummary = NSTextField; 
-                voice = NJRVoicePopUpButton; 
-                wakeUp = NSButtonCell; 
-            }; 
-            SUPERCLASS = NSWindowController; 
-        }, 
-        {
-            CLASS = PSAlarmsController; 
-            LANGUAGE = ObjC; 
-            OUTLETS = {tableView = NSTableView; }; 
-            SUPERCLASS = NSWindowController; 
-        }, 
-        {
-            ACTIONS = {
-                orderFrontAlarmsPanel = id; 
-                orderFrontPreferencesPanel = id; 
-                orderFrontSetAlarmPanel = id; 
-                stopAlerts = id; 
-            }; 
-            CLASS = PSApplication; 
-            LANGUAGE = ObjC; 
-            OUTLETS = {alarmSetController = PSAlarmSetController; }; 
-            SUPERCLASS = NSApplication; 
-        }
-    ); 
-    IBVersion = 1; 
-}
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>IBClasses</key>
+	<array>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>stopVoicePreview</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>NJRVoicePopUpButton</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSPopUpButton</string>
+		</dict>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>dateCompleted</key>
+				<string>NSPopUpButton</string>
+				<key>doScriptChanged</key>
+				<string>id</string>
+				<key>doSpeakChanged</key>
+				<string>id</string>
+				<key>editAlertChanged</key>
+				<string>id</string>
+				<key>inAtChanged</key>
+				<string>id</string>
+				<key>playSoundChanged</key>
+				<string>id</string>
+				<key>setAlarm</key>
+				<string>NSButton</string>
+				<key>setSoundRepetitionCount</key>
+				<string>id</string>
+				<key>showCalendar</key>
+				<string>NSButton</string>
+				<key>showVolume</key>
+				<string>NSButton</string>
+				<key>silence</key>
+				<string>id</string>
+				<key>toggleAlertEditor</key>
+				<string>id</string>
+				<key>update</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>PSAlarmSetController</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>OUTLETS</key>
+			<dict>
+				<key>alertTabs</key>
+				<string>NSTabView</string>
+				<key>alertView</key>
+				<string>NSTextField</string>
+				<key>bounceDockIcon</key>
+				<string>NSButton</string>
+				<key>cancelButton</key>
+				<string>NSButton</string>
+				<key>displayMessage</key>
+				<string>NSButtonCell</string>
+				<key>doScript</key>
+				<string>NSButtonCell</string>
+				<key>doSpeak</key>
+				<string>NSButtonCell</string>
+				<key>editAlert</key>
+				<string>NSButtonCell</string>
+				<key>inAtMatrix</key>
+				<string>NSMatrix</string>
+				<key>messageField</key>
+				<string>NSTextField</string>
+				<key>playSound</key>
+				<string>NSButtonCell</string>
+				<key>script</key>
+				<string>NJRFSObjectSelector</string>
+				<key>scriptSelectButton</key>
+				<string>NSButton</string>
+				<key>setButton</key>
+				<string>NSButton</string>
+				<key>sound</key>
+				<string>NJRQTMediaPopUpButton</string>
+				<key>soundRepetitionStepper</key>
+				<string>NSStepper</string>
+				<key>soundRepetitions</key>
+				<string>NSTextField</string>
+				<key>soundRepetitionsLabel</key>
+				<string>NSTextField</string>
+				<key>soundVolumeButton</key>
+				<string>NSButton</string>
+				<key>timeCalendarButton</key>
+				<string>NSButton</string>
+				<key>timeDate</key>
+				<string>NSTextField</string>
+				<key>timeDateCompletions</key>
+				<string>NSPopUpButton</string>
+				<key>timeInterval</key>
+				<string>NJRIntervalField</string>
+				<key>timeIntervalRepeats</key>
+				<string>NSButton</string>
+				<key>timeIntervalUnits</key>
+				<string>NSPopUpButton</string>
+				<key>timeOfDay</key>
+				<string>NSTextField</string>
+				<key>timeSummary</key>
+				<string>NSTextField</string>
+				<key>voice</key>
+				<string>NJRVoicePopUpButton</string>
+				<key>wakeUp</key>
+				<string>NSButtonCell</string>
+			</dict>
+			<key>SUPERCLASS</key>
+			<string>NSWindowController</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NSDisclosureButtonCell</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSButtonCell</string>
+		</dict>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>clearAllEntries</key>
+				<string>id</string>
+				<key>removeEntry</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>NJRHistoryTrackingComboBox</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSComboBox</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NSMenuItem</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSObject</string>
+		</dict>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>stopSoundPreview</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>NJRQTMediaPopUpButton</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>OUTLETS</key>
+			<dict>
+				<key>preview</key>
+				<string>NSMovieView</string>
+			</dict>
+			<key>SUPERCLASS</key>
+			<string>NSPopUpButton</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>FirstResponder</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSObject</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NJRUnfocusableMovieView</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSMovieView</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NSObject</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NJRIntervalField</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>OUTLETS</key>
+			<dict>
+				<key>intervalUnits</key>
+				<string>NSPopUpButton</string>
+			</dict>
+			<key>SUPERCLASS</key>
+			<string>NSTextField</string>
+		</dict>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>orderFrontAlarmsPanel</key>
+				<string>id</string>
+				<key>orderFrontPreferencesPanel</key>
+				<string>id</string>
+				<key>orderFrontSetAlarmPanel</key>
+				<string>id</string>
+				<key>stopAlerts</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>PSApplication</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>OUTLETS</key>
+			<dict>
+				<key>alarmSetController</key>
+				<string>PSAlarmSetController</string>
+			</dict>
+			<key>SUPERCLASS</key>
+			<string>NSApplication</string>
+		</dict>
+		<dict>
+			<key>CLASS</key>
+			<string>NJRIntegerFilter</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSNumberFormatter</string>
+		</dict>
+		<dict>
+			<key>ACTIONS</key>
+			<dict>
+				<key>select</key>
+				<string>id</string>
+			</dict>
+			<key>CLASS</key>
+			<string>NJRFSObjectSelector</string>
+			<key>LANGUAGE</key>
+			<string>ObjC</string>
+			<key>SUPERCLASS</key>
+			<string>NSButton</string>
+		</dict>
+	</array>
+	<key>IBVersion</key>
+	<string>1</string>
+</dict>
+</plist>
Index: trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib
===================================================================
--- trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 348)
+++ trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 355)
@@ -1,44 +1,20 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
-	<key>IBDocumentLocation</key>
-	<string>63 2 356 240 0 0 1280 832 </string>
-	<key>IBEditorPositions</key>
-	<dict>
-		<key>29</key>
-		<string>130 241 273 44 0 0 1280 832 </string>
-		<key>640</key>
-		<string>63 247 111 180 0 0 1280 832 </string>
-	</dict>
 	<key>IBFramework Version</key>
-	<string>291.0</string>
+	<string>629</string>
+	<key>IBLastKnownRelativeProjectPath</key>
+	<string>../../Pester.xcodeproj</string>
+	<key>IBOldestOS</key>
+	<integer>5</integer>
 	<key>IBOpenObjects</key>
 	<array>
-		<integer>640</integer>
-		<integer>21</integer>
+		<integer>2</integer>
 	</array>
 	<key>IBSystem Version</key>
-	<string>6I32</string>
-	<key>IBUserGuides</key>
-	<dict>
-		<key>21</key>
-		<dict>
-			<key>guideLocations</key>
-			<array>
-				<string>Horizontal:122.000000</string>
-				<string>Horizontal:178.000000</string>
-				<string>Horizontal:192.000000</string>
-				<string>Vertical:36.000000</string>
-				<string>Vertical:16.000000</string>
-				<string>Vertical:85.000000</string>
-				<string>Vertical:422.000000</string>
-				<string>Horizontal:150.000000</string>
-				<string>Horizontal:150.000000</string>
-			</array>
-			<key>guidesLocked</key>
-			<false/>
-		</dict>
-	</dict>
+	<string>9B18</string>
+	<key>targetFramework</key>
+	<string>IBCocoaFramework</string>
 </dict>
 </plist>
Index: trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m	(revision 355)
@@ -1,3 +1,4 @@
 #import "NJRFSObjectSelector.h"
+#import "NSMenuItem-NJRExtensions.h"
 #import "NSImage-NJRExtensions.h"
 #import "NSString-NJRExtensions.h"
@@ -84,4 +85,5 @@
 - (void)setImage:(NSImage *)image;
 {
+    // XXX change to use IconRef; see ICeCoffEELabeledIconCell and Google
     [super setImage: [image bestFitImageForSize: [[self cell] cellSize]]];
 }
@@ -111,5 +113,6 @@
         NSAssert1([files count] == 1, @"%d items returned, only one expected", [files count]);
         [self setPath: [files objectAtIndex: 0]];
-        [[self target] tryToPerform: [self action] with: self];
+		if ([self target] != nil && [[self target] respondsToSelector:[self action]])
+			[[self target] performSelector: [self action] withObject: self];
     }
 }
@@ -145,4 +148,5 @@
             }
             do {
+                NSAssert1(![path isEqualToString: revealPath], @"Stuck on path |%@|", [alias fullPath]);
                 item = [menu addItemWithTitle: [fmgr displayNameAtPath: path]
                                        action: @selector(revealInFinder:)
@@ -150,9 +154,7 @@
                 [item setTarget: self];
                 [item setRepresentedObject: revealPath];
-                [item setImage:
-                    [[[NSWorkspace sharedWorkspace] iconForFile: path] bestFitImageForSize: NSMakeSize(16, 16)]];
+                [item setImageFromPath: path];
                 revealPath = path;
                 path = [path stringByDeletingLastPathComponent];
-                NSAssert1(![path isEqualToString: revealPath], @"Stuck on path |%@|", [alias fullPath]);
             } while (![revealPath isEqualToString: @"/"] && ![path isEqualToString: @"/Volumes"]);
             [[self cell] setMenu: menu];
@@ -195,4 +197,6 @@
 - (void)mouseDown:(NSEvent *)theEvent;
 {
+    if (![self isEnabled]) return;
+    
     NSMenu *menu = [[self cell] menu];
     MenuRef mRef = _NSGetCarbonMenu(menu);
@@ -219,7 +223,8 @@
                                   pressure: [theEvent pressure]];
 
-    // this undocumented API does not work any better; contextual menu items are still added:
-    // [menu _popUpMenuWithEvent: theEvent forView: self];
-    [NSMenu popUpContextMenu: menu withEvent: theEvent forView: self];
+    // XXX otherwise Cocoa thoughtfully doesn't give me the font I want
+    NSFont *font = [[self cell] font];
+    [NSMenu popUpContextMenu: menu withEvent: theEvent forView: self withFont: 
+     [NSFont fontWithName: [font fontName] size: [font pointSize] - 0.001]];
 }
 
@@ -310,5 +315,6 @@
         if (url == nil) return NO;
         [self setPath: [url path]];
-        [[self target] tryToPerform: [self action] with: self];
+		if ([self target] != nil && [[self target] respondsToSelector:[self action]])
+			[[self target] performSelector: [self action] withObject: self];
     }
     return YES;
Index: trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 355)
@@ -27,5 +27,4 @@
     [self removeAllItems];
     [self addItemsWithObjectValues: [[NSUserDefaults standardUserDefaults] stringArrayForKey: [self _defaultKey]]];
-    [self setItemHeight: [self itemHeight] + 2];
 }
 
Index: trunk/Cocoa/Pester/Source/NJRHotKey.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHotKey.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRHotKey.m	(revision 355)
@@ -39,4 +39,5 @@
 {
     [hotKeyCharacters release];
+    [super dealloc];
 }
 
Index: trunk/Cocoa/Pester/Source/NJRHotKeyField.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHotKeyField.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRHotKeyField.m	(revision 355)
@@ -65,4 +65,5 @@
 {
     [hotKey release];
+    [super dealloc];
 }
 
Index: trunk/Cocoa/Pester/Source/NJRHotKeyManager.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRHotKeyManager.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRHotKeyManager.m	(revision 355)
@@ -32,4 +32,5 @@
     [hotKey release];
     [target release];
+    [super dealloc];
 }
 
Index: trunk/Cocoa/Pester/Source/NJRIntervalField.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 355)
@@ -84,5 +84,5 @@
     NSString *alertMessage = nil;
     NSString *alternateButtonString = nil;
-    NSDecimalNumber *proposedValue = nil;
+    NSNumber *proposedValue = nil;
     NSDictionary *contextInfo;
 
Index: trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m	(revision 355)
@@ -8,15 +8,12 @@
 
 #import "NJRQTMediaPopUpButton.h"
-#import "SoundFileManager.h"
 #import "NJRSoundManager.h"
 #import "NSMovie-NJRExtensions.h"
-#import "NSImage-NJRExtensions.h"
-#import <QuickTime/Movies.h>
-
-// XXX workaround for SoundFileManager log message in 10.2.3 and earlier
-#include <stdio.h>
-#include <unistd.h>
-#include <fcntl.h>
-// XXX end workaround
+#import "NSMenuItem-NJRExtensions.h"
+
+#import <QTKit/QTKit.h>
+
+#include <QuickTime/Movies.h>
+#include <limits.h>
 
 static const int NJRQTMediaPopUpButtonMaxRecentItems = 10;
@@ -66,5 +63,5 @@
     [item setTarget: self];
     [item setRepresentedObject: alias];
-    [item setImage: [[[NSWorkspace sharedWorkspace] iconForFile: path] bestFitImageForSize: NSMakeSize(16, 16)]];
+    [item setImageFromPath: path];
     [recentMediaAliasData addObject: [alias aliasData]];
     if ([recentMediaAliasData count] > NJRQTMediaPopUpButtonMaxRecentItems) {
@@ -115,29 +112,63 @@
 - (void)_setUp;
 {
-    NSMenu *menu;
-    NSMenuItem *item;
-    SoundFileManager *sfm = [SoundFileManager sharedSoundFileManager];
-    int soundCount = [sfm count];
-
+    NSMenu *menu = [self menu];
     [self removeAllItems];
-    menu = [self menu];
-    item = [menu addItemWithTitle: @"Alert sound" action: @selector(_beepSelected:) keyEquivalent: @""];
+    [menu setAutoenablesItems: NO];
+
+    NSMenuItem *item = [menu addItemWithTitle: @"Alert sound" action: @selector(_beepSelected:) keyEquivalent: @""];
     [item setTarget: self];
     [menu addItem: [NSMenuItem separatorItem]];
-    if (soundCount == 0) {
+
+    NSMutableArray *soundFolderPaths = [[NSMutableArray alloc] initWithCapacity: kLastDomainConstant - kSystemDomain + 1];
+    for (FSVolumeRefNum domain = kSystemDomain ; domain <= kLastDomainConstant ; domain++) {
+	OSStatus err;
+	FSRef fsr;
+	err = FSFindFolder(domain, kSystemSoundsFolderType, false, &fsr);
+	if (err != noErr) continue;
+
+	UInt8 path[PATH_MAX];
+	err = FSRefMakePath(&fsr, path, PATH_MAX);
+	if (err != noErr) continue;
+
+	CFStringRef pathString = CFStringCreateWithFileSystemRepresentation(NULL, (const char *)path);
+	if (pathString == NULL) continue;
+
+	[soundFolderPaths addObject: (NSString *)pathString];
+	CFRelease(pathString);
+    }
+    NSFileManager *fm = [NSFileManager defaultManager];
+    NSEnumerator *e = [soundFolderPaths objectEnumerator];
+    NSString *folderPath;
+    while ( (folderPath = [e nextObject]) != nil) {
+	if (![fm changeCurrentDirectoryPath: folderPath]) continue;
+
+	NSDirectoryEnumerator *de = [fm enumeratorAtPath: folderPath];
+	NSString *path;
+	while ( (path = [de nextObject]) != nil) {
+	    BOOL isDir;
+	    if (![fm fileExistsAtPath: path isDirectory: &isDir] || isDir) {
+		[de skipDescendents];
+		continue;
+	    }
+
+	    if (![QTMovie canInitWithFile: path]) continue;
+	    
+	    item = [menu addItemWithTitle: [fm displayNameAtPath: path]
+				   action: @selector(_systemSoundSelected:)
+			    keyEquivalent: @""];
+            [item setTarget: self];
+            [item setImageFromPath: path];
+	    path = [folderPath stringByAppendingPathComponent: path];
+            [item setRepresentedObject: path];
+	    [item setToolTip: path];
+        }
+    }
+    [soundFolderPaths release];
+    
+    if ([menu numberOfItems] == 2) {
         item = [menu addItemWithTitle: NSLocalizedString(@"Can't locate alert sounds", "QuickTime media popup menu item surrogate for alert sound list if no sounds are found") action: nil keyEquivalent: @""];
         [item setEnabled: NO];
-    } else {
-        SoundFile *sf;
-        int i;
-        [sfm sortByName];
-        for (i = 0 ; i < soundCount ; i++) {
-            sf = [sfm soundFileAtIndex: i];
-            item = [menu addItemWithTitle: [sf name] action: @selector(_soundFileSelected:) keyEquivalent: @""];
-            [item setTarget: self];
-            [item setRepresentedObject: sf];
-            [item setImage: [[[NSWorkspace sharedWorkspace] iconForFile: [sf path]] bestFitImageForSize: NSMakeSize(16, 16)]];
-        }
-    }
+    }
+	 
     [menu addItem: [NSMenuItem separatorItem]];
     item = [menu addItemWithTitle: NSLocalizedString(@"Other...", "Media popup item to select another sound/movie/image") action: @selector(select:) keyEquivalent: @""];
@@ -212,29 +243,14 @@
 - (NSMenuItem *)_itemForAlias:(BDAlias *)alias;
 {
-    NSString *path;
-    SoundFile *sf;
-    if (alias == nil) {
-        return [self itemAtIndex: 0];
-    }
+    if (alias == nil) return [self itemAtIndex: 0];
 
     // [self _validateRecentMedia];
-    path = [alias fullPath];
-    {   // XXX suppress log message from Apple's code:
-        // 2002-12-14 14:09:58.740 Pester[26529] Could not find sound type for directory /Users/nicholas/Desktop
-        int errfd = dup(STDERR_FILENO), nullfd = open("/dev/null", O_WRONLY, 0);
-        // need to have something open in STDERR_FILENO because if it isn't,
-        // NSLog will log to /dev/console
-        dup2(nullfd, STDERR_FILENO);
-        close(nullfd);
-        sf = [[SoundFileManager sharedSoundFileManager] soundFileFromPath: path];
-        dup2(errfd, STDERR_FILENO);
-        close(errfd);
-    }
-    // NSLog(@"_itemForAlias: %@", path);
+    NSString *path = [alias fullPath];
 
     // selected a system sound?
-    if (sf != nil) {
+    int itemIndex = [[self menu] indexOfItemWithRepresentedObject: path];
+    if (itemIndex != -1) {
         // NSLog(@"_itemForAlias: selected system sound");
-        return [self itemAtIndex: [self indexOfItemWithRepresentedObject: sf]];
+        return [self itemAtIndex: itemIndex];
     } else {
         NSEnumerator *e = [recentMediaAliasData reverseObjectEnumerator];
@@ -406,7 +422,7 @@
 }
 
-- (void)_soundFileSelected:(NSMenuItem *)sender;
-{
-    [self _setPath: [(SoundFile *)[sender representedObject] path]];
+- (void)_systemSoundSelected:(NSMenuItem *)sender;
+{
+    [self _setPath: [sender representedObject]];
     if (![self _validateWithPreview: YES]) {
         [[self menu] removeItem: sender];
Index: trunk/Cocoa/Pester/Source/NJRReadMeController.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRReadMeController.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRReadMeController.m	(revision 355)
@@ -64,5 +64,5 @@
     unsigned i;
     for (i = 0 ; i < level ; i++) {
-        [s appendString: @"ÊÊ"];
+        [s appendString: @"  "];
     }
     [s appendString: description];
@@ -101,5 +101,5 @@
         NSString *frameAutosaveName;
         if ( (frameAutosaveName = [window frameAutosaveName]) == nil) {
-            // XXX workaround for bug in 10.1.5Ð10.2.4 (at least): autosave name set in IB doesn't show up
+            // XXX workaround for bug in 10.1.5–10.2.4 (at least): autosave name set in IB doesn't show up
             [self setWindowFrameAutosaveName: @"Read Me"];
             frameAutosaveName = [window frameAutosaveName];
Index: trunk/Cocoa/Pester/Source/NJRSoundManager.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRSoundManager.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRSoundManager.m	(revision 355)
@@ -34,5 +34,5 @@
 
     propertySize = sizeof(stereoChannels);
-    err = AudioDeviceGetProperty(deviceID, NULL, false, kAudioDevicePropertyPreferredChannelsForStereo, &propertySize, &stereoChannels);
+    err = AudioDeviceGetProperty(deviceID, 0, false, kAudioDevicePropertyPreferredChannelsForStereo, &propertySize, &stereoChannels);
     if (err != noErr) return NO;
     return YES;
Index: trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m
===================================================================
--- trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m	(revision 355)
@@ -21,5 +21,5 @@
     [menu setAutoenablesItems: NO];
     // XXX would be more elegant with surrogate support like my font popup menu
-    item = [menu addItemWithTitle: @"ÇunknownÈ" action: nil keyEquivalent: @""];
+    item = [menu addItemWithTitle: @"«unknown»" action: nil keyEquivalent: @""];
     [item setEnabled: NO];
     [menu addItem: [NSMenuItem separatorItem]];
Index: trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.h
===================================================================
--- trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.h	(revision 355)
+++ trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.h	(revision 355)
@@ -0,0 +1,16 @@
+//
+//  NSMenuItem-NJRExtensions.h
+//  Pester
+//
+//  Created by Nicholas Riley on 11/22/07.
+//  Copyright 2007 Nicholas Riley. All rights reserved.
+//
+
+#import <Cocoa/Cocoa.h>
+
+
+@interface NSMenuItem (NJRExtensions)
+
+- (void)setImageFromPath:(NSString *)path;
+
+@end
Index: trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.m
===================================================================
--- trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.m	(revision 355)
+++ trunk/Cocoa/Pester/Source/NSMenuItem-NJRExtensions.m	(revision 355)
@@ -0,0 +1,35 @@
+//
+//  NSMenuItem-NJRExtensions.m
+//  Pester
+//
+//  Created by Nicholas Riley on 11/22/07.
+//  Copyright 2007 Nicholas Riley. All rights reserved.
+//
+
+#import "NSMenuItem-NJRExtensions.h"
+
+@interface NSMenuItem (Private)
+- (void)_setIconRef:(IconRef)iconRef;
+@end
+
+@implementation NSMenuItem (NJRExtensions)
+
+// from ICeCoffEE's ICCF_CopyIconRefForPath
+- (void)setImageFromPath:(NSString *)path;
+{
+    IconRef icon;
+    FSRef fsr;
+    SInt16 label;
+    OSStatus err = noErr;
+    
+    err = FSPathMakeRef((const UInt8 *)[path fileSystemRepresentation], &fsr, NULL);
+    if (err != noErr) return;
+    
+    err = GetIconRefFromFileInfo(&fsr, 0, NULL, kFSCatInfoNone, NULL, kIconServicesNormalUsageFlag, &icon, &label);
+    if (err != noErr) return;
+    
+    [self _setIconRef: icon];
+    ReleaseIconRef(icon);
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/PSAlarm.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 355)
@@ -343,5 +343,5 @@
     NSString *timeRemainingString = [self _stringForInterval: llround([self timeRemaining])];
     
-    if (timeRemainingString == nil) return @"ÇexpiredÈ";
+    if (timeRemainingString == nil) return @"«expired»";
     return timeRemainingString;
 }
Index: trunk/Cocoa/Pester/Source/PSAlarmSetController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 355)
@@ -373,4 +373,6 @@
         [[self window] makeFirstResponder: scriptSelectButton];
         if ([script alias] == nil) [scriptSelectButton performClick: sender];
+    } else {
+	[[self window] makeFirstResponder: sender];
     }
 }
@@ -382,4 +384,6 @@
     if (doSpeakSelected && sender != nil)
         [[self window] makeFirstResponder: voice];
+    else
+	[[self window] makeFirstResponder: sender];	
 }
 
Index: trunk/Cocoa/Pester/Source/PSAlarms.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSAlarms.m	(revision 355)
@@ -176,6 +176,6 @@
     NSEnumerator *e = [indices objectEnumerator];
     NSNumber *n;
-    int indexCount = [indices count], i = 0, alarmIndex;
-    int *indexArray = (int *)malloc(indexCount * sizeof(int));
+    unsigned indexCount = [indices count], i = 0, alarmIndex;
+    unsigned *indexArray = (unsigned *)malloc(indexCount * sizeof(unsigned));
     NS_DURING
         while ( (n = [e nextObject]) != nil) {
Index: trunk/Cocoa/Pester/Source/PSAlarmsController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 355)
@@ -106,5 +106,5 @@
         if ([[tableColumn identifier] isEqualToString: @"date"]) return [alarm shortDateString];
         if ([[tableColumn identifier] isEqualToString: @"time"]) {
-            if (date == nil) return @"ÇexpiredÈ";
+            if (date == nil) return @"«expired»";
             return [alarm timeString];
         }
Index: trunk/Cocoa/Pester/Source/PSAlerts.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSAlerts.m	(revision 355)
@@ -41,4 +41,5 @@
 {
     [alerts release]; alerts = nil;
+    [super dealloc];
 }
 
@@ -121,5 +122,7 @@
         [plAlerts addObject: [alert propertyListRepresentation]];
     }
-    return [NSDictionary dictionaryWithObject: plAlerts forKey: PLAlerts];
+    NSDictionary *dict = [NSDictionary dictionaryWithObject: plAlerts forKey: PLAlerts];
+    [plAlerts release];
+    return dict;
 }
 
Index: trunk/Cocoa/Pester/Source/PSPowerManager.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 348)
+++ trunk/Cocoa/Pester/Source/PSPowerManager.h	(revision 355)
@@ -21,7 +21,5 @@
 
 + (BOOL)autoWakeSupported;
-+ (NSDate *)wakeTime;
-+ (void)setWakeInterval:(unsigned long)wakeInterval;
-+ (void)setWakeTime:(NSDate *)time overrideIfEarlier:(BOOL)override;
++ (void)setWakeTime:(NSDate *)time;
 + (void)clearWakeTime;
 
